## liblockdev 0.9a

=== Makefile ===
# this include do nothing if nor run as a sub-make of debian/rules
-include debian/policy


libname	= liblockdev

objs	= src/lockdev.o


VER	= $(shell expr `pwd` : '.*-\([0-9.]*\)')
MVER	= ${shell expr `pwd` : '.*-\([0-9]*\).[0-9]*'}

static	= ${libname}.a
shared	= ${libname}.so.${VER}
soname	= ${libname}.so.${MVER}

# overwritten by caller (e.g.: debian/rules)
basedir	= /usr/local
srcdir=.

libdir	= ${basedir}/lib
incdir	= ${basedir}/include
mandir	= ${basedir}/man

CC	= gcc
CFLAGS	= "-g -O2 -fPIC -Wall -pipe -D_REENTRANT"

ALL:	shared static perl-lib

install:	install_dev install_dbg install_doc install_run

static ${static}:       ${objs}
	$(AR) $(ARFLAGS) ${static} $^

shared ${shared}:	${objs}
	${CC} ${CFLAGS} -shared -Wl,-soname,${soname} $^ -lc ${LIBS} -o ${shared}

perl-lib:	static
	cd LockDev && perl Makefile.PL INSTALLDIRS=perl
	cd LockDev && make
	cd LockDev && make test

install_dev:	${static} src/lockdev.h
	install -m755 -d	${libdir}
	install -m644 ${static}	${libdir}
	install -m755 -d	${incdir}
	install -m644 src/lockdev.h	${incdir}

install_debug:	${static} ${shared}
	install -m755 -d	${libdir}/debug
	install -m644 ${static}	${libdir}/debug
	install -m644 ${shared}	${libdir}/debug/${soname}

install_profile:	${static} ${shared}
	install -m755 -d	${libdir}/profile
	install -m644 ${static}	${libdir}/profile
	install -m644 ${shared}	${libdir}/profile/${soname}

install_doc:	docs/lockdev.3
	install -m755 -d	${mandir}/man3
	install -m644 docs/lockdev.3	${mandir}/man3

install_run:	${shared}
	install -m755 -d	${libdir}
	install -m644 ${shared}	${libdir}

perl-clean:	clean
	cd LockDev && rm -rf *~ *.o LockDev.bs LockDev.c \
		Makefile Makefile.old blib pm_to_blib 

clean:
	-find . -name '*~' | xargs --no-run-if-empty  rm -f 
	-find . -name '*.o' | xargs --no-run-if-empty  rm -f 

mostyclean:	clean
	-rm -f *.a *.so *.so.*
	-rm -f shared static debug profile _SRCDIR_

distclean:	mostyclean perl-clean

distribute:
	${MAKE} -f debian/rules clean
	cd .. 	&& tar -cvf - ${libname}-${VER} | gzip -9c > ${libname}_${VER}.tgz

.PHONY: install install_dev install_doc install_run clean distclean perl-clean distribute

=== debian/changelog ===
liblockdev (0.9a) frozen unstable; urgency=low

  * Added more tests in postinst of liblockdev0g-dbg, to avoid strange
    problems encountered by Adam P. Harris (closes: #22565)

 -- Fabrizio Polacco <fpolacco@debian.org>  Mon, 18 May 1998 15:21:12 +0300

liblockdev (0.9) frozen unstable; urgency=low

  * cleaned symlinks in docs dirs.
  * changed libs symlinks from /usr/lib to /lib
  * stripped main shared library.
  * Corrected wrong shlibs dependency (thanx to Hamish Moffatt, 
    closes: #22282).
  * Changed dependency of -dev from libc6 to libc6-dev, 
    thanx to James Troup (closes: #16476).
  * Added -I.. in Makefile.PL to allow compilation of the perl part even
    when the -dev package isn't installed (thanx to Martin Schulze for
    the patch) closes: #15834

 -- Fabrizio Polacco <fpolacco@debian.org>  Tue, 12 May 1998 13:39:27 +0300

liblockdev (0.8) unstable; urgency=low

  * updated manpage (degugging section).
  * added environment variable to set debug value, and signals 
    to change those values at runtime (if compiled with -DDEBUG).
  * avoided symlink to /usr/src changing .stab in asm source 
    file (overwritten implicit rule to produce asm source).
    Thanx to Martin Schulze <joey> for the help.
  * changed dbg package to install shared debug lib in 
    /usr/lib/debug and profile lib in /usr/lib/profile.
  * splitted debian/rules in included debian/policy
  * cleaned Makefile and changed to build debug shared lib.
    Thanx to Yann Dirson.
  * added change in umask value to allow full permissions to lock 
    files.  (this is questionable: would it be better to add a 
    suid program to check and remove dangling locks?)

 -- Fabrizio Polacco <fpolacco@debian.org>  Tue, 23 Dec 1997 11:26:10 +0200

liblockdev (0.7) unstable; urgency=low

  * cleaned Makefile and debian/rules
  * change in Makefile.PL to allow pristine compilation on new systems
    (closes: #15834, thanx to Martin Schulze).
  * added -dbg package with debug and profile libs.
  * problem with lenght of dev_t in glibc for printf: cast needed :-)
  * corrected ftp address in copyright file.

 -- Fabrizio Polacco <fpolacco@debian.org>  Sun, 30 Nov 1997 01:00:50 +0200

liblockdev (0.6) unstable; urgency=low

  * added symlink to dirs in /usr/doc (one dir for all packages),
     now /usr/doc/liblockdev is a symlink installed by -dev package,
     as the liblockdev.a and liblockdev.so symlinks.
     Instead, lblockdev-perl installs a copy of the docs because
     it doesn't depend on the run-time binary package (as -dev does).
  * cleaned spreading in the distribution: 
     source and run-time to section 'libs', development into 'devel',
     perl module into 'interpreters' (waiting for a perl section).
  * created extension perl library LockDev:: with manpage LockDev(3pm)
     and packaged as liblockdev0-perl.
  * moved symlink so.0 -> so.0.6 to runtime package.
  * added unlink of semaphore file (not really needed, just to clean up)
  * corrected error in Synopsis of manpage (oops).
  * cleaned source code: changed ANSI-C definition of functions to K&R,
     as recommended in GNU coding style (but not for indentation).
     Added ANSI-C prototypes for internal functions (exported one 
     already have them in .h interface file.
  * cleaned rules file, got rid of unneeded libc5 compatibility.
  * Moved back include of stdio.h from lockdev.h to .c (closes:Bug#14154)
     Thanx to Juan Cespedes <cespedes@debian.org>
  * Corrected debian/rules to have binary-arch rule (closes:Bug#14062)

 -- Fabrizio Polacco <fpolacco@debian.org>  Wed, 22 Oct 1997 13:45:34 +0300

liblockdev (0.5) unstable; urgency=low

  * moved to libc6 (glibc2); added a "g" after soname in package name.
  * added rules to build also compatibility libc5 libs.

 -- Fabrizio Polacco <fpolacco@debian.org>  Thu, 25 Sep 1997 11:51:22 +0300

liblockdev0 (0.4) unstable; urgency=low

  * Changed priority from extra to optional.
  * cleaned Makefile and added separate static/debug library.
  * Cleaned include file.
  * Added global var liblockdev_debug for debugging level
  * Added 2 functions to set and reset debugging level (only in static lib)

 -- Fabrizio Polacco <fpolacco@debian.org>  Sat,  6 Sep 1997 02:20:01 +0300

liblockdev0 (0.3) unstable; urgency=low

  * avoided stripping of static lib (compiled with -DDEBUG)
  * added semaphore lock to avoid race condition in
    removing stale locks (thanx to Barak Pearlmutter)
  * changed unlink of stale lock to a complex and
    convoluted way to avoid conflicts between us and another
    process that doesn't use this library. Still exists the
    possibility of a conflict between two other processes that
    don't use this library, but we are safe.
  * cleaned code in lock_dev()

 -- Fabrizio Polacco <fpolacco@debian.org>  Fri,  5 Sep 1997 11:05:21 +0300

liblockdev0 (0.2) unstable; urgency=low

  * fixed shared lib links.

 -- Fabrizio Polacco <fpolacco@debian.org>  Thu,  4 Sep 1997 19:08:38 +0300

liblockdev0 (0.1) unstable; urgency=low

  * Initial Release.

 -- Fabrizio Polacco <fpolacco@debian.org>  Thu,  4 Sep 1997 14:13:23 +0300

=== debian/control ===
Source: liblockdev
Section: libs
Priority: optional
Maintainer: Fabrizio Polacco <fpolacco@debian.org>
Standards-Version: 2.4.0

Package: liblockdev0g
Section: libs
Architecture: any
Depends: ${shlibs:Depends}
Conflicts: liblockdev0
Replaces: liblockdev0
Description: Run-time shared library (libc6) for locking devices.
 It provides a reliable way to put an exclusive lock to
 devices using _both_ FSSTND and SVr4 methods.

Package: liblockdev0g-dev
Section: devel
Architecture: any
Depends: liblockdev0g (=${Source-Version}), libc6-dev
Conflicts: liblockdev0-dev
Replaces: liblockdev0-dev
Description: Development library (libc6) for locking devices.
 It provides a reliable way to put an exclusive lock to
 devices using _both_ FSSTND and SVr4 methods.
 .
 Includes header files and static lib.

Package: liblockdev0g-dbg
Section: devel
Architecture: any
Depends: liblockdev0g-dev (=${Source-Version})
Description: Debugging library (libc6) for locking devices.
 It provides a reliable way to put an exclusive lock to
 devices using _both_ FSSTND and SVr4 methods.
 .
 Includes static and shared debugging and profiling libs.

Package: liblockdev0-perl
Section: interpreters
Architecture: any
Depends: perl (>= 5.004.02)
Description: perl extension library for locking devices.
 It provides a reliable way to put an exclusive lock to
 devices using _both_ FSSTND and SVr4 methods.
 .
 Includes a shared lib loadable by perl 5 (use LockDev),
 the module LockDev.pm and its manpage LockDev(3pm) .

=== debian/rules ===
#!/usr/bin/make -f
# makefile to build a shared library as a debian binary package
# modifyed to handle alternate libc

libname=liblockdev
package=${libname}${version_major}g

_debian_policy_ = 1
-include debian/policy

#

build:
	${checkdir}
	-${MAKE} mostyclean
	${MAKE} shared CFLAGS="-O2 -fPIC -fomit-frame-pointer"
	${MAKE} perl-lib
	touch build

.PHONY: clean 
clean:	
	${checkdir}
	-rm -f out build build-* _SRCDIR_
	-${MAKE} distclean
	${update_standards_version} debian/control
	-rm -f `find . -name "*~"`
	-rm -rf debian/tmp `find debian/* -type d ! -name CVS`
	-rm -f debian/*substvars debian/files* core


binary-indep:	checkroot build
	${checkdir}
# There are no architecture-independent files to be uploaded
# generated by this package. If there were any they would be
# made here.

binary-run:	checkroot build
	${checkdir}
	-rm -rf ${d_build}
	#
	# need to create dirs by hand
	${install_dir}	${d_dirs} 
	#
	# ==== DEBIAN control files ====
	cd debian && ${install_DEBIAN_scripts}
	# shlibs dependency
	echo -e "${libname}\t${version_major}\t${package}" \
		> ${d_deb}/shlibs
	# ==== make install ====
	${MAKE} install_run basedir=${d_usr}
	# move libs to /lib
	mv ${d_ulib}/* ${d_lib}
	strip --strip-unneeded 	${d_lib}/${libname}.so.${version}	
	# ==== symlink for shared libs to work ====
	ln -s ${libname}.so.${version}	${d_lib}/${libname}.so.${version_major}
	#
	# ==== docs ====
	# particular documents that must be present with exactly this name
	cd debian && ${install_data}	changelog \
				${d_doc}/changelog.Debian
	cd debian && ${install_data}	copyright \
				${d_doc}/copyright
	#
	# now compress only large documents
	cd ${d_doc} && ${compress_docs}
	#
	# ==== clean dirs ====
	-${clean_dirs}
	# ==== md5sums ====
	cd ${d_build} && ${install_md5sums}
	# ==== finds dependencies ====
	dpkg-shlibdeps ${d_lib}/*
	# ==== process control file ====
	dpkg-gencontrol -p${package}
	chown -R root.root ${d_build}
	chmod -R go=rX ${d_build}
	dpkg --build ${d_build} ..

binary-dev:	checkroot
	# now add static libs, include file and manpage
	${checkdir}
	-rm -rf ${d_build}
	#
	# need to create dirs by hand
	${install_dir}	${d_dirs} 
	ln -s ${package} ${d_doc}-dev
	#
	# ==== make install ====
	-${MAKE} mostyclean
	${MAKE} static CFLAGS="-g3 -O2"
	${MAKE} install_dev basedir=${d_usr}
	strip --strip-debug 	${d_ulib}/${libname}.a
	# ==== symlink for shared libs to work ====
	ln -s ${libname}.so.${version}	${d_lib}/${libname}.so
	#
	# ==== manpages ====
	${MAKE} install_doc basedir=${d_usr}
	gzip -r9 ${d_man}
	#
	# ==== clean dirs ====
	-${clean_dirs}
	# ==== md5sums ====
	cd ${d_build} && ${install_md5sums}
	# ==== process control file ====
	dpkg-gencontrol -p${package}-dev
	chown -R root.root ${d_build}
	chmod -R go=rX ${d_build}
	dpkg --build ${d_build} ..

binary-dbg:	checkroot
	# now add static libs with debug and profiling enabled
	${checkdir}
	-rm -rf ${d_build}
	#
	# need to create dirs by hand
	${install_dir}	${d_dirs} ${d_doc}-dbg
	#
	# ==== DEBIAN control files ====
	prefix="dbg_" && cd debian && ${install_DEBIAN_scripts}
	#
	# ==== make install ====
	-${MAKE} mostyclean
	${MAKE} shared CFLAGS="-g3 -O2 -fPIC -DDEBUG" create_debug_lib=1
	${MAKE} install_debug basedir=${d_usr}
	-${MAKE} mostyclean
	${MAKE} shared CFLAGS="-g3 -pg -fPIC"
	${MAKE} install_profile basedir=${d_usr}
	#
	# ==== sources ====
	${install_sources}
	#
	# ==== docs ====
	cd debian && ${install_data}	README.debug	${d_doc}-dbg
	# now compress only large documents
	cd ${d_doc}-dbg && ${compress_docs}
	#
	# ==== clean dirs ====
	-${clean_dirs}
	# ==== md5sums ====
	cd ${d_build} && ${install_md5sums}
	# ==== process control file ====
	dpkg-gencontrol -p${package}-dbg
	chown -R root.root ${d_build}
	chmod -R go=rX ${d_build}
	dpkg --build ${d_build} ..

binary-perl:	checkroot build
	${checkdir}
	-rm -rf ${d_build}
	#
	# need to create dirs by hand
	${install_dir}	${d_dirs} ${d_doc}-perl ${d_man}/man3
	#
	# ==== docs ====
	# particular documents that must be present with exactly this name
	cd debian && ${install_data}	changelog \
			${d_doc}-perl/changelog.Debian
	cd debian && ${install_data}	copyright \
			${d_doc}-perl/copyright
	#
	# now compress only large documents
	cd ${d_doc}-perl && ${compress_docs}
	#
	# ==== make install ====
	cd LockDev && $(MAKE) pure_perl_install manifypods \
		INST_MAN3DIR=${d_man}/man3 \
		PREFIX=${d_usr} 
	-find ${d_build} -type f -name .packlist | xargs rm -f
	gzip -r9 ${d_man}
	#
	# ==== clean dirs ====
	-${clean_dirs}
	# ==== md5sums ====
	cd ${d_build} && ${install_md5sums}
	# ==== process control file ====
	dpkg-gencontrol -p${libname}${version_major}-perl
	chown -R root.root ${d_build}
	chmod -R go=rX ${d_build}
	dpkg --build ${d_build} ..


binary-arch:	binary-run binary-dev binary-dbg binary-perl


.PHONY: binary binary-indep binary-arch binary-run binary-dev 
binary:		binary-indep binary-arch

.PHONY: checkroot 
checkroot:
	test root = "`whoami`"
